# This file was automatically generated by bifcl from /usr/src/bro-2.5.5/src/analyzer/protocol/conn-size/functions.bif (plugin mode).

export {


## Sets the current byte threshold for connection sizes, overwriting any potential old
## threshold. Be aware that in nearly any case you will want to use the high level API
## instead (ConnThreshold::set_bytes_threshold).
##
## cid: The connection id.
##
## threshold: Threshold in bytes.
##
## is_orig: If true, threshold is set for bytes from originator, otherwhise for bytes from responder.
##
## .. bro:see:: set_current_conn_packets_threshold conn_bytes_threshold_crossed conn_packets_threshold_crossed
##              get_current_conn_bytes_threshold get_current_conn_packets_threshold
global set_current_conn_bytes_threshold: function(cid: conn_id , threshold: count , is_orig: bool ): bool ;


## Sets a threshold for connection packets, overwtiting any potential old thresholds.
## Be aware that in nearly any case you will want to use the high level API
## instead (ConnThreshold::set_packets_threshold).
##
## cid: The connection id.
##
## threshold: Threshold in packets.
##
## is_orig: If true, threshold is set for packets from originator, otherwhise for packets from responder.
##
## .. bro:see:: set_current_conn_bytes_threshold conn_bytes_threshold_crossed conn_packets_threshold_crossed
##              get_current_conn_bytes_threshold get_current_conn_packets_threshold
global set_current_conn_packets_threshold: function(cid: conn_id , threshold: count , is_orig: bool ): bool ;


## Gets the current byte threshold size for a connection.
##
## cid: The connection id.
##
## is_orig: If true, threshold of originator, otherwhise threshold of responder.
##
## Returns: 0 if no threshold is set or the threshold in bytes
##
## .. bro:see:: set_current_conn_packets_threshold conn_bytes_threshold_crossed conn_packets_threshold_crossed
##              get_current_conn_packets_threshold
global get_current_conn_bytes_threshold: function(cid: conn_id , is_orig: bool ): count ;


## Gets the current packet threshold size for a connection.
##
## cid: The connection id.
##
## is_orig: If true, threshold of originator, otherwhise threshold of responder.
##
## Returns: 0 if no threshold is set or the threshold in packets
##
## .. bro:see:: set_current_conn_packets_threshold conn_bytes_threshold_crossed conn_packets_threshold_crossed
##              get_current_conn_bytes_threshold
global get_current_conn_packets_threshold: function(cid: conn_id , is_orig: bool ): count ;


} # end of export section
module GLOBAL;
