// This file was automatically generated by bifcl from /usr/src/bro-2.5.5/src/analyzer/protocol/conn-size/functions.bif (plugin mode).


#include "functions.bif.h"


#line 1 "functions.bif"

#include "analyzer/protocol/conn-size/ConnSize.h"

static analyzer::Analyzer* GetConnsizeAnalyzer(Val* cid)
	{
	Connection* c = sessions->FindConnection(cid);
	if ( ! c )
		{
		reporter->Error("cannot find connection");
		return 0;
		}

	analyzer::Analyzer* a = c->FindAnalyzer("CONNSIZE");
	if ( ! a )
		reporter->Error("connection does not have ConnSize analyzer");

	return a;
	}


#line 34 "functions.bif"
Val* BifFunc::bro_set_current_conn_bytes_threshold(Frame* frame, val_list* BiF_ARGS)
	
#line 35 "functions.bif"
{
	if ( BiF_ARGS->length() != 3 )
		{
		reporter->Error("set_current_conn_bytes_threshold() takes exactly 3 argument(s)");
		return 0;
		}
	Val* cid = (Val*) ((*BiF_ARGS)[0]);
	bro_uint_t threshold = (bro_uint_t) ((*BiF_ARGS)[1]->AsCount());
	int is_orig = (int) ((*BiF_ARGS)[2]->AsBool());

#line 35 "functions.bif"

	analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return new Val(0, TYPE_BOOL);

	static_cast<analyzer::conn_size::ConnSize_Analyzer*>(a)->SetThreshold(threshold, 1, is_orig);

	return new Val(1, TYPE_BOOL);
	} // end of BifFunc::bro_set_current_conn_bytes_threshold

#line 43 "functions.bif"

#line 57 "functions.bif"
Val* BifFunc::bro_set_current_conn_packets_threshold(Frame* frame, val_list* BiF_ARGS)
	
#line 58 "functions.bif"
{
	if ( BiF_ARGS->length() != 3 )
		{
		reporter->Error("set_current_conn_packets_threshold() takes exactly 3 argument(s)");
		return 0;
		}
	Val* cid = (Val*) ((*BiF_ARGS)[0]);
	bro_uint_t threshold = (bro_uint_t) ((*BiF_ARGS)[1]->AsCount());
	int is_orig = (int) ((*BiF_ARGS)[2]->AsBool());

#line 58 "functions.bif"

	analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return new Val(0, TYPE_BOOL);

	static_cast<analyzer::conn_size::ConnSize_Analyzer*>(a)->SetThreshold(threshold, 0, is_orig);

	return new Val(1, TYPE_BOOL);
	} // end of BifFunc::bro_set_current_conn_packets_threshold

#line 66 "functions.bif"

#line 78 "functions.bif"
Val* BifFunc::bro_get_current_conn_bytes_threshold(Frame* frame, val_list* BiF_ARGS)
	
#line 79 "functions.bif"
{
	if ( BiF_ARGS->length() != 2 )
		{
		reporter->Error("get_current_conn_bytes_threshold() takes exactly 2 argument(s)");
		return 0;
		}
	Val* cid = (Val*) ((*BiF_ARGS)[0]);
	int is_orig = (int) ((*BiF_ARGS)[1]->AsBool());

#line 79 "functions.bif"

	analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return new Val(0, TYPE_COUNT);

	return new Val(
		static_cast<analyzer::conn_size::ConnSize_Analyzer*>(a)->GetThreshold(1, is_orig),
		TYPE_COUNT);
	} // end of BifFunc::bro_get_current_conn_bytes_threshold

#line 87 "functions.bif"

#line 99 "functions.bif"
Val* BifFunc::bro_get_current_conn_packets_threshold(Frame* frame, val_list* BiF_ARGS)
	
#line 100 "functions.bif"
{
	if ( BiF_ARGS->length() != 2 )
		{
		reporter->Error("get_current_conn_packets_threshold() takes exactly 2 argument(s)");
		return 0;
		}
	Val* cid = (Val*) ((*BiF_ARGS)[0]);
	int is_orig = (int) ((*BiF_ARGS)[1]->AsBool());

#line 100 "functions.bif"

	analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return new Val(0, TYPE_COUNT);

	return new Val(
		static_cast<analyzer::conn_size::ConnSize_Analyzer*>(a)->GetThreshold(0, is_orig),
		TYPE_COUNT);
	} // end of BifFunc::bro_get_current_conn_packets_threshold

#line 108 "functions.bif"
