// This file is automatically generated from /usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi.pac.

#ifndef _builddir_build_BUILD_bro_2_5_5_src_analyzer_protocol_gssapi_gssapi_pac_h
#define _builddir_build_BUILD_bro_2_5_5_src_analyzer_protocol_gssapi_gssapi_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


#include "analyzer/Manager.h"
#include "analyzer/Analyzer.h"

#include "events.bif.h"


#include <cstdlib>

namespace binpac {

namespace GSSAPI {
class ContextGSSAPI;
class GSSAPI_Conn;
class GSSAPI_NEG_TOKEN;
class GSSAPI_NEG_TOKEN_INIT;
class GSSAPI_NEG_TOKEN_INIT_Arg;
class GSSAPI_NEG_TOKEN_INIT_Arg_Data;
class GSSAPI_NEG_TOKEN_RESP;
class GSSAPI_NEG_TOKEN_RESP_Arg;
class GSSAPI_NEG_TOKEN_MECH_TOKEN;
enum ASN1TypeTag {
	ASN1_INTEGER_TAG = 2,
	ASN1_OCTET_STRING_TAG = 4,
	ASN1_NULL_TAG = 5,
	ASN1_OBJECT_IDENTIFIER_TAG = 6,
	ASN1_SEQUENCE_TAG = 48,
	ASN1_APP_TAG_OFFSET = 96,
	ASN1_INDEX_TAG_OFFSET = 160,
};
class ASN1Encoding;
class ASN1EncodingMeta;
class ASN1OptionalEncodingMeta;
class ASN1SequenceMeta;
class ASN1Integer;
class ASN1OctetString;
class ASN1ObjectIdentifier;
class ASN1Boolean;
class ASN1Enumerated;
class SequenceElement;
class Array;
class GSSAPI_Flow;
} // namespace GSSAPI

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
StringVal * utf16_bytestring_to_utf8_val(Connection * conn, bytestring const & utf16);
namespace GSSAPI {

class ContextGSSAPI
{
public:
	ContextGSSAPI(GSSAPI_Conn * connection, GSSAPI_Flow * flow);
	~ContextGSSAPI();
	
	// Member access functions
	GSSAPI_Conn * connection() const { return connection_; }
	GSSAPI_Flow * flow() const { return flow_; }
	
protected:
	GSSAPI_Conn * connection_;
	GSSAPI_Flow * flow_;
};


class GSSAPI_Conn : public binpac::ConnectionAnalyzer
{
public:
	GSSAPI_Conn(BroAnalyzer const & bro_analyzer);
	~GSSAPI_Conn();
	
	// Member access functions
	GSSAPI_Flow * upflow() const { return upflow_; }
	GSSAPI_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	bool forward_blob(GSSAPI_NEG_TOKEN_MECH_TOKEN * val, bool is_orig);
	bool proc_gssapi_neg_result(GSSAPI_NEG_TOKEN_RESP_Arg * val);
	
protected:
	
	// Additional members

		analyzer::Analyzer *ntlm;
		analyzer::Analyzer *krb5;
	
	GSSAPI_Flow * upflow_;
	GSSAPI_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class GSSAPI_NEG_TOKEN
{
public:
	GSSAPI_NEG_TOKEN(bool is_orig);
	~GSSAPI_NEG_TOKEN();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	ASN1EncodingMeta * wrapper() const { return wrapper_; }
	int have_oid_case_index() const	{ return have_oid_case_index_; }
	ASN1Encoding * oid() const
		{
		switch ( have_oid_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:5:oid", have_oid_case_index(), "true");
				break;
			}
		return oid_;
		}
	int have_init_wrapper_case_index() const	{ return have_init_wrapper_case_index_; }
	ASN1EncodingMeta * init_wrapper() const
		{
		switch ( have_init_wrapper_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:9:init_wrapper", have_init_wrapper_case_index(), "true");
				break;
			}
		return init_wrapper_;
		}
	int msg_type_case_index() const	{ return msg_type_case_index_; }
	GSSAPI_NEG_TOKEN_INIT * init() const
		{
		switch ( msg_type_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:13:init", msg_type_case_index(), "true");
				break;
			}
		return init_;
		}
	GSSAPI_NEG_TOKEN_RESP * resp() const
		{
		switch ( msg_type_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:14:resp", msg_type_case_index(), "false");
				break;
			}
		return resp_;
		}
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	bool is_init() const { return is_init_; }
	
protected:
	ASN1EncodingMeta * wrapper_;
	int have_oid_case_index_;
	ASN1Encoding * oid_;
	int have_init_wrapper_case_index_;
	ASN1EncodingMeta * init_wrapper_;
	int msg_type_case_index_;
	GSSAPI_NEG_TOKEN_INIT * init_;
	GSSAPI_NEG_TOKEN_RESP * resp_;
	bool is_orig_;
	int byteorder_;
	bool is_init_;
};


class GSSAPI_NEG_TOKEN_INIT
{
public:
	GSSAPI_NEG_TOKEN_INIT();
	~GSSAPI_NEG_TOKEN_INIT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	ASN1EncodingMeta * seq_meta() const { return seq_meta_; }
	vector<GSSAPI_NEG_TOKEN_INIT_Arg *> * args() const { return args_; }
	
protected:
	ASN1EncodingMeta * seq_meta_;
	vector<GSSAPI_NEG_TOKEN_INIT_Arg *> * args_;
	GSSAPI_NEG_TOKEN_INIT_Arg * args__elem_;
};


class GSSAPI_NEG_TOKEN_INIT_Arg
{
public:
	GSSAPI_NEG_TOKEN_INIT_Arg();
	~GSSAPI_NEG_TOKEN_INIT_Arg();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	ASN1EncodingMeta * seq_meta() const { return seq_meta_; }
	GSSAPI_NEG_TOKEN_INIT_Arg_Data * args() const { return args_; }
	
protected:
	ASN1EncodingMeta * seq_meta_;
	GSSAPI_NEG_TOKEN_INIT_Arg_Data * args_;
};


class GSSAPI_NEG_TOKEN_INIT_Arg_Data
{
public:
	GSSAPI_NEG_TOKEN_INIT_Arg_Data(uint8 index);
	~GSSAPI_NEG_TOKEN_INIT_Arg_Data();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	ASN1Encoding * mech_type_list() const
		{
		switch ( val_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:31:mech_type_list", val_case_index(), "((int) 0)");
				break;
			}
		return mech_type_list_;
		}
	ASN1Encoding * req_flags() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:32:req_flags", val_case_index(), "((int) 1)");
				break;
			}
		return req_flags_;
		}
	GSSAPI_NEG_TOKEN_MECH_TOKEN * mech_token() const
		{
		switch ( val_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:33:mech_token", val_case_index(), "((int) 2)");
				break;
			}
		return mech_token_;
		}
	ASN1OctetString * mech_list_mic() const
		{
		switch ( val_case_index() )
			{
			case 3:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:34:mech_list_mic", val_case_index(), "((int) 3)");
				break;
			}
		return mech_list_mic_;
		}
	uint8 index() const { return index_; }
	
protected:
	int val_case_index_;
	ASN1Encoding * mech_type_list_;
	ASN1Encoding * req_flags_;
	GSSAPI_NEG_TOKEN_MECH_TOKEN * mech_token_;
	ASN1OctetString * mech_list_mic_;
	uint8 index_;
};


class GSSAPI_NEG_TOKEN_RESP
{
public:
	GSSAPI_NEG_TOKEN_RESP();
	~GSSAPI_NEG_TOKEN_RESP();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	ASN1EncodingMeta * seq_meta() const { return seq_meta_; }
	vector<GSSAPI_NEG_TOKEN_RESP_Arg *> * args() const { return args_; }
	
protected:
	ASN1EncodingMeta * seq_meta_;
	vector<GSSAPI_NEG_TOKEN_RESP_Arg *> * args_;
	GSSAPI_NEG_TOKEN_RESP_Arg * args__elem_;
};


class GSSAPI_NEG_TOKEN_RESP_Arg
{
public:
	GSSAPI_NEG_TOKEN_RESP_Arg();
	~GSSAPI_NEG_TOKEN_RESP_Arg();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	ASN1EncodingMeta * seq_meta() const { return seq_meta_; }
	int args_case_index() const	{ return args_case_index_; }
	ASN1Integer * neg_state() const
		{
		switch ( args_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:45:neg_state", args_case_index(), "((int) 0)");
				break;
			}
		return neg_state_;
		}
	ASN1Encoding * supported_mech() const
		{
		switch ( args_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:46:supported_mech", args_case_index(), "((int) 1)");
				break;
			}
		return supported_mech_;
		}
	GSSAPI_NEG_TOKEN_MECH_TOKEN * response_token() const
		{
		switch ( args_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:47:response_token", args_case_index(), "((int) 2)");
				break;
			}
		return response_token_;
		}
	ASN1OctetString * mech_list_mic() const
		{
		switch ( args_case_index() )
			{
			case 3:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/gssapi-protocol.pac:48:mech_list_mic", args_case_index(), "((int) 3)");
				break;
			}
		return mech_list_mic_;
		}
	bool proc() const { BINPAC_ASSERT(has_proc()); return proc_; }
	bool has_proc() const { return has_proc_; }
	
protected:
	ASN1EncodingMeta * seq_meta_;
	int args_case_index_;
	ASN1Integer * neg_state_;
	ASN1Encoding * supported_mech_;
	GSSAPI_NEG_TOKEN_MECH_TOKEN * response_token_;
	ASN1OctetString * mech_list_mic_;
	bool proc_;
	bool has_proc_;
};


class GSSAPI_NEG_TOKEN_MECH_TOKEN
{
public:
	GSSAPI_NEG_TOKEN_MECH_TOKEN(bool is_orig);
	~GSSAPI_NEG_TOKEN_MECH_TOKEN();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGSSAPI * t_context);
	
	// Member access functions
	ASN1EncodingMeta * meta() const { return meta_; }
	bytestring const & mech_token() const { return mech_token_; }
	bool is_orig() const { return is_orig_; }
	bool fwd() const { return fwd_; }
	
protected:
	ASN1EncodingMeta * meta_;
	bytestring mech_token_;
	bool is_orig_;
	bool fwd_;
};


	Val* asn1_integer_to_val(const ASN1Encoding* i, TypeTag t);
	Val* asn1_integer_to_val(const ASN1Integer* i, TypeTag t);
	StringVal* asn1_oid_to_val(const ASN1Encoding* oid);
	StringVal* asn1_oid_to_val(const ASN1ObjectIdentifier* oid);
	StringVal* asn1_octet_string_to_val(const ASN1Encoding* s);
	StringVal* asn1_octet_string_to_val(const ASN1OctetString* s);


class ASN1Encoding
{
public:
	ASN1Encoding();
	~ASN1Encoding();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1EncodingMeta * meta() const { return meta_; }
	bytestring const & content() const { return content_; }
	
protected:
	ASN1EncodingMeta * meta_;
	bytestring content_;
};


class ASN1EncodingMeta
{
public:
	ASN1EncodingMeta();
	~ASN1EncodingMeta();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 tag() const { return tag_; }
	uint8 len() const { return len_; }
	bytestring const & more_len() const { return more_len_; }
	bool long_len() const { return long_len_; }
	uint64 length() const { return length_; }
	uint8 index() const { return index_; }
	
protected:
	uint8 tag_;
	uint8 len_;
	bytestring more_len_;
	bool long_len_;
	uint64 length_;
	uint8 index_;
};


class ASN1OptionalEncodingMeta
{
public:
	ASN1OptionalEncodingMeta(bool is_present, ASN1EncodingMeta * previous_metadata);
	~ASN1OptionalEncodingMeta();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	ASN1EncodingMeta * data() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/../asn1/asn1.pac:42:data", val_case_index(), "true");
				break;
			}
		return data_;
		}
	bool is_present() const { return is_present_; }
	ASN1EncodingMeta * previous_metadata() const { return previous_metadata_; }
	uint64 length() const { return length_; }
	
protected:
	int val_case_index_;
	ASN1EncodingMeta * data_;
	bool is_present_;
	ASN1EncodingMeta * previous_metadata_;
	uint64 length_;
};


class ASN1SequenceMeta
{
public:
	ASN1SequenceMeta();
	~ASN1SequenceMeta();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1EncodingMeta * encoding() const { return encoding_; }
	
protected:
	ASN1EncodingMeta * encoding_;
};


class ASN1Integer
{
public:
	ASN1Integer();
	~ASN1Integer();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1Encoding * encoding() const { return encoding_; }
	
protected:
	ASN1Encoding * encoding_;
};


class ASN1OctetString
{
public:
	ASN1OctetString();
	~ASN1OctetString();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1Encoding * encoding() const { return encoding_; }
	
protected:
	ASN1Encoding * encoding_;
};


class ASN1ObjectIdentifier
{
public:
	ASN1ObjectIdentifier();
	~ASN1ObjectIdentifier();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1Encoding * encoding() const { return encoding_; }
	
protected:
	ASN1Encoding * encoding_;
};


class ASN1Boolean
{
public:
	ASN1Boolean();
	~ASN1Boolean();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1Encoding * encoding() const { return encoding_; }
	
protected:
	ASN1Encoding * encoding_;
};


class ASN1Enumerated
{
public:
	ASN1Enumerated();
	~ASN1Enumerated();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1Encoding * encoding() const { return encoding_; }
	
protected:
	ASN1Encoding * encoding_;
};


class SequenceElement
{
public:
	SequenceElement(bool grab_content);
	~SequenceElement();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1EncodingMeta * index_meta() const { return index_meta_; }
	int have_content_case_index() const	{ return have_content_case_index_; }
	ASN1Encoding * data() const
		{
		switch ( have_content_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/../asn1/asn1.pac:75:data", have_content_case_index(), "true");
				break;
			}
		return data_;
		}
	ASN1EncodingMeta * meta() const
		{
		switch ( have_content_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/usr/src/bro-2.5.5/src/analyzer/protocol/gssapi/../asn1/asn1.pac:76:meta", have_content_case_index(), "false");
				break;
			}
		return meta_;
		}
	bool grab_content() const { return grab_content_; }
	uint8 index() const { return index_; }
	uint64 length() const { return length_; }
	
protected:
	ASN1EncodingMeta * index_meta_;
	int have_content_case_index_;
	ASN1Encoding * data_;
	ASN1EncodingMeta * meta_;
	bool grab_content_;
	uint8 index_;
	uint64 length_;
};


class Array
{
public:
	Array();
	~Array();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ASN1EncodingMeta * array_meta() const { return array_meta_; }
	vector<ASN1Encoding *> * data() const { return data_; }
	
protected:
	ASN1EncodingMeta * array_meta_;
	vector<ASN1Encoding *> * data_;
	ASN1Encoding * data__elem_;
};

int64 binary_to_int64(bytestring const & bs);

class GSSAPI_Flow : public binpac::FlowAnalyzer
{
public:
	GSSAPI_Flow(GSSAPI_Conn * connection, bool is_orig);
	~GSSAPI_Flow();
	
	// Member access functions
	GSSAPI_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	GSSAPI_NEG_TOKEN * dataunit_;
	ContextGSSAPI * context_;
	GSSAPI_Conn * connection_;
	bool is_orig_;
};

} // namespace GSSAPI
}  // namespace binpac
#endif /* _builddir_build_BUILD_bro_2_5_5_src_analyzer_protocol_gssapi_gssapi_pac_h */
