// This file is automatically generated from /usr/src/bro-2.5.5/src/analyzer/protocol/xmpp/xmpp.pac.

#ifndef _builddir_build_BUILD_bro_2_5_5_src_analyzer_protocol_xmpp_xmpp_pac_h
#define _builddir_build_BUILD_bro_2_5_5_src_analyzer_protocol_xmpp_xmpp_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


#include "events.bif.h"

namespace analyzer { namespace xmpp { class XMPP_Analyzer; } }
namespace binpac { namespace XMPP { class XMPP_Conn; } }
typedef analyzer::xmpp::XMPP_Analyzer* XMPPAnalyzer;

#include "XMPP.h"

namespace binpac {

namespace XMPP {
class ContextXMPP;
class XMPP_Conn;
extern RegExMatcher XML_START_re_001;

class XML_START;
extern RegExMatcher XML_END_re_002;

class XML_END;
extern RegExMatcher XML_NAME_re_003;

class XML_NAME;
extern RegExMatcher XML_REST_re_004;

class XML_REST;
extern RegExMatcher SPACING_re_005;

class SPACING;
extern RegExMatcher CONTENT_re_006;

class CONTENT;
class XMPP_PDU;
class XMPP_TOKEN;
class XMPP_Flow;
} // namespace XMPP

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
StringVal * utf16_bytestring_to_utf8_val(Connection * conn, bytestring const & utf16);
namespace XMPP {

class ContextXMPP
{
public:
	ContextXMPP(XMPP_Conn * connection, XMPP_Flow * flow);
	~ContextXMPP();
	
	// Member access functions
	XMPP_Conn * connection() const { return connection_; }
	XMPP_Flow * flow() const { return flow_; }
	
protected:
	XMPP_Conn * connection_;
	XMPP_Flow * flow_;
};


class XMPP_Conn : public binpac::ConnectionAnalyzer
{
public:
	XMPP_Conn(XMPPAnalyzer const & bro_analyzer);
	~XMPP_Conn();
	
	// Member access functions
	XMPP_Flow * upflow() const { return upflow_; }
	XMPP_Flow * downflow() const { return downflow_; }
	XMPPAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	bool proc_xmpp_token(bool is_orig, bytestring const & name, bytestring const & rest);
	
protected:
	
	// Additional members

	bool client_starttls;
	
	XMPP_Flow * upflow_;
	XMPP_Flow * downflow_;
	XMPPAnalyzer bro_analyzer_;
};


class XMPP_PDU
{
public:
	XMPP_PDU(bool is_orig);
	~XMPP_PDU();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextXMPP * t_context);
	
	// Member access functions
	vector<XMPP_TOKEN *> * val() const { return val_; }
	bool is_orig() const { return is_orig_; }
	int size() const	{ return val() ? val()->size() : 0; }
	XMPP_TOKEN * operator[](int index) const { BINPAC_ASSERT(val()); return (*val())[index]; }
	
protected:
	vector<XMPP_TOKEN *> * val_;
	bool is_orig_;
	XMPP_TOKEN * val__elem_;
};


class XMPP_TOKEN
{
public:
	XMPP_TOKEN(bool is_orig);
	~XMPP_TOKEN();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextXMPP * t_context);
	
	// Member access functions
	bytestring const & anonymous_field_007() const { return anonymous_field_007_; }
	bytestring const & anonymous_field_008() const { return anonymous_field_008_; }
	bytestring const & name() const { return name_; }
	bytestring const & rest() const { return rest_; }
	bytestring const & anonymous_field_009() const { return anonymous_field_009_; }
	bytestring const & tagcontent() const { return tagcontent_; }
	bool is_orig() const { return is_orig_; }
	bool proc() const { return proc_; }
	
protected:
	bytestring anonymous_field_007_;
	bytestring anonymous_field_008_;
	bytestring name_;
	bytestring rest_;
	bytestring anonymous_field_009_;
	bytestring tagcontent_;
	bool is_orig_;
	bool proc_;
};


class XMPP_Flow : public binpac::FlowAnalyzer
{
public:
	XMPP_Flow(XMPP_Conn * connection, bool is_orig);
	~XMPP_Flow();
	
	// Member access functions
	XMPP_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	XMPP_PDU * dataunit_;
	ContextXMPP * context_;
	XMPP_Conn * connection_;
	bool is_orig_;
};

} // namespace XMPP
}  // namespace binpac
#endif /* _builddir_build_BUILD_bro_2_5_5_src_analyzer_protocol_xmpp_xmpp_pac_h */
